;|
    GEOTiff.LSP
    Copyright  2004 Michel Loftus
  ----------------------------------------------------------------|;

(defun c:tfw (/ img file res pt xres yres xrot yrot left top) ;define the function name and variables
  (if (setq im (ssget ":s" '((0 . "IMAGE")))) ;select the image to scale
    (progn
      (setq imG (vlax-ename->vla-object (ssname im 0)))
      (if (findfile (vl-string-subst ".ers" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	(setq file (vl-string-subst ".ers" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	(if (findfile (vl-string-subst ".tfw" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	  (setq file (vl-string-subst ".tfw" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	  (if (findfile (vl-string-subst ".jpw" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	    (setq file (vl-string-subst ".jpw" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	    (if (findfile (vl-string-subst ".pgw" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	      (setq file (vl-string-subst ".pgw" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)))
	      )
	    )
	  )
	)
      (if (or file (setq file (getfiled "Select World File" (vl-string-subst "" (vl-filename-extension (vla-get-imagefile img)) (vla-get-imagefile img)) "tfw;jgw;pgw;ers" 0)))
	(if (= (vl-filename-extension file) ".ers")
	  (progn
	    (setq file (open file "r"))
	    (repeat 19 (read-line file))
	    (setq left (atof (last (split (read-line file)  " ")))
		  top (atof (last (split (read-line file)  " ")))
		  )
	    (close file)
	    (vla-put-origin img (vlax-list->variant (list left (- top (vla-get-height img)) 0.0)))
	    (vla-put-imagewidth img (vla-get-width img))
	    (vla-put-imageheight img (vla-get-height img))
	    (vla-getboundingbox img 'minpt 'maxpt)
	    (vla-zoomwindow (vlax-get-acad-object) minpt maxpt)
	    )
	  (progn
	    (setq file (open file "r")
		  xres (atof (read-line file))
		  xrot (atof (read-line file))
		  yrot (atof (read-line file))
		  yres (atof (read-line file))
		  ins (list (atof (read-line file)) (atof (read-line file)) 0.0)
		  ins (polar ins (* (/ (+ xrot 90.0) 180.0) pi) (* (vla-get-height img) yres))
		  )
	    (close file)
	    (vla-put-rotation img (degrad xrot))
	    (vla-put-origin img (vlax-list->variant ins))
	    (vla-put-imageheight img (* (vla-get-height img) (abs yres)))
	    (vla-put-imagewidth img (* (vla-get-width img) (abs xres)))
	    (vla-getboundingbox img 'minpt 'maxpt)
	    (vla-zoomwindow (vlax-get-acad-object) minpt maxpt)
	    )
	  )
	)
      )
    )
  (princ) ;exit quietly
)

(defun c:worldfile (/ sel filename file xscale yscale ang pt)
  (if (setq sel (ssget ":s" '((0 . "IMAGE"))))
    (progn
      (setq sel (vlax-ename->vla-object (ssname sel 0)))
      (if (setq filename (getfiled "Save World File As"
				   (strcat
				     (vl-filename-directory (vla-get-imagefile sel))
				     "\\"
				     (vl-filename-base (vla-get-imagefile sel))
				     (cdr (assoc
					    (vl-filename-extension (vla-get-imagefile sel))
					    (list (cons ".tif" ".tfw") (cons ".png" ".pgw") (cons ".jpg" "jpw"))
					    )
					  )
				     )
				   (cdr (assoc
					    (vl-filename-extension (vla-get-imagefile sel))
					    (list (cons ".tif" "tfw") (cons ".png" "pgw") (cons ".jpg" "jpw"))
					    )
					  )
				   1
				   )
		)
	(progn
	  (setq xscale (/ (vla-get-imagewidth sel) (vla-get-width sel))
		yscale (/ (vla-get-imageheight sel) (vla-get-height sel) -1.0)
		ang (vla-get-rotation sel)
		pt (polar (vl-val (vla-get-origin sel)) (+ ang (/ pi 2)) (vla-get-imageheight sel))
		)
	  (setq file (open filename "w"))
	  (princ (rtos xscale 2 6) file)
	  (princ "\n" file)
	  (princ (rtos (raddeg ang) 2 6) file)
	  (princ "\n" file)
	  (princ (rtos (raddeg (+ ang (/ pi 2.0))) 2 6) file)
	  (princ "\n" file)
	  (princ (rtos yscale 2 6) file)
	  (princ "\n" file)
	  (princ (rtos (car pt) 2 6) file)
	  (princ "\n" file)
	  (princ (rtos (cadr pt) 2 6) file)
	  (princ "\n" file)
	  (close file)
	  )
	)
      )
    )
  (princ)
  )